//
// TextOutput.cpp
//
// Raun M Krisch
//
// routines to handle text output in opengl
// 
// code is based of the tutorials from http://www.lighthouse3d.com
//


#include "Fonts.h"
#include <iostream.h>

void *textFont = 0;

//
// textSetRasterFont
//
//
//
void textSetBitmapFont(void *font) {
  
  // if no argument is sent or the argument is null
  // then set a default font
  if(!font) {
    textFont = GLUT_BITMAP_HELVETICA_12;
      //GLUT_BITMAP_HELVETICA_18;
      //GLUT_BITMAP_TIMES_ROMAN_24;
      //GLUT_BITMAP_TIMES_ROMAN_10;
  } else {
    textFont = font;
  }
}

//
// textPrintf()
//
//
// args:
//
// return: none
//
void textPrintf(GLfloat xCoord, GLfloat yCoord, char *string, GLboolean updateRasPos) {
  char *c;
  
  glPushMatrix();
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  if(updateRasPos) {
    glRasterPos3f(xCoord, yCoord, 0);
  }
  glColor3f(1.0, 1.0, 1.0);

  for (c=string; *c != '\0'; c++) {
    glutBitmapCharacter(textFont, *c);
  }

  glPopMatrix();

}

//
// textPrinti()
//
//
void textPrintf(GLfloat xCoord, GLfloat yCoord, GLint number, GLboolean updateRasPos) {
  
  GLbyte thousands;
  GLbyte hundreds;
  GLbyte tens;
  GLbyte ones;
  GLbyte numberOffset = 48;

  glPushMatrix();
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  if(updateRasPos) {
    glRasterPos3f(xCoord, yCoord, 0);
  }

  glColor3f(1.0, 1.0, 1.0);

  thousands = number / 1000 + numberOffset;
  hundreds  = number % 1000 / 100 + numberOffset;
  tens      = number % 1000 % 100 / 10 + numberOffset;
  ones      = number % 1000 % 100 % 10 + numberOffset;

  if(thousands > numberOffset) {

    glutBitmapCharacter(textFont, thousands);
    glutBitmapCharacter(textFont, hundreds);
    glutBitmapCharacter(textFont, tens);
    glutBitmapCharacter(textFont, ones);

  } else if(hundreds > numberOffset) {

    glutBitmapCharacter(textFont, hundreds);
    glutBitmapCharacter(textFont, tens);
    glutBitmapCharacter(textFont, ones);

  } else if(tens > numberOffset) {
   
    glutBitmapCharacter(textFont, tens);
    glutBitmapCharacter(textFont, ones);

  } else {
  
    glutBitmapCharacter(textFont, ones);
  
  }

  glPopMatrix();

}

