#ifndef  _GAME_TIMER_H
#define  _GAME_TIMER_H

#ifdef WIN32
  #pragma message( "WIN32 found - attempting to link to winmm.lib" )
  #pragma comment(lib ,"winmm.lib")
  #include <windows.h>
#endif

//
// (C) Copyright 1999-2002 by Eike Anderson, all rights reserved
// contact: mailto:mishka@gmx.net
//
// Permission to use, copy, and distribute for non-commercial purposes,    
// is hereby granted without fee, providing that the above copyright       
// notice appear in all copies and that both the copyright notice and      
// this permission notice appear in supporting documentation.              
//
// The software may be modified for your own purposes, but modified        
// versions may not be distributed.                                        
//
// This software is provided "as is" without any expressed or implied      
// guarantee or warranty.                                                  
//
// This software is NOT in the public domain.                 
//

#define PALFPS         25
#define NTSCFPS        30
#define FILMFPS        24
#define MINIMUMSMOOTH  15

class gameTimer
{
   private:
    LONGLONG now;       // current time
    LONGLONG then;      // last time
    LONGLONG tFreq;     // performance counter frequency
    float tScale;       // time scale
    float elapsed;      // time elapsed since last update
    int   max_fps;      // maximum desired framerate
    bool flag;          // timer availability flag
	
   public:
        gameTimer();
        ~gameTimer();
        void update();          // update the timer - call this function once every frame
        void wait();            // holds execution to enforce the maximum framerate
        void wait(int);         // waits for the amount of specified milliseconds
        void maxFPS(int);       // set the maximum framerate
        void useNTSC();         // use NTSC framerate
        void usePAL();          // use PAL framerate
        void useFILM();         // use FILM framerate
        void useMINS();         // use MINIMUMSMOOTH framerate
        int  getMaxFPS();       // retrieve the maximum framerate
        float getElapsed();     // get the number of elapsed milliseconds
        float getFPS();         // get the framerate
};

#endif