#include <windows.h>
#include "GL/glut.h"
#include "gameTimer.h"
#include <list>
#include <math.h>
#include <iostream.h>
#include <time.h>
#include "Fonts.h"

#define PI 3.1415926535898
#define DECAY 8

#define WIN_WIDTH  720 
#define WIN_HEIGHT  576

// user types

using namespace std;

typedef void (*fp)();

struct listNode
{
	double xpos,ypos;
	double xspeed,yspeed;
	fp renderFunction;
	//fp renderFunctionLine;
	GLfloat color[4];
	GLfloat color1[4];
	double expiryDate;
	GLfloat sizeX;
	GLfloat sizeY;
	GLfloat angle;
};

using namespace std;

// global variables
list<listNode> linkedList;		// STL list container
list<listNode> linkedList1;		// STL list container
gameTimer timer;				// high precision timer function
gameTimer wordsPerMinute;
gameTimer keysPerMinute;
fp lookup_table[26];
fp lookup_tableLine[26];



// function prototypes
void initLookupTableLine();
void initLookupTable();

void update(list<listNode> &base,double elapsed);	// list update function
void draw(list<listNode> &base);						// list drawing function
void drawLine(list<listNode> &base);						// list drawing function

void makeColor(GLfloat *c,GLfloat r, GLfloat g, GLfloat b,GLfloat a);
float decay (float d);

void drawShape2();									// draw shape2
void drawShape2Line();
void drawX();										// draw X
void drawXLine();	
void drawCracker();									// draw cracker
void drawCrackerLine();
void drawCross();									// draw cross
void drawCrossLine();
void drawZigZag();									// draw zigzag
void drawZigZagLine();	
void draw4Star();									// draw 4star
void draw4StarLine();
void drawVan();										// draw van
void drawVanLine();	
void drawHeart();									// draw heart
void drawHeartLine();
void drawHammer();									// draw hammer
void drawHammerLine();
void drawRightArrow();								// draw rightArrow
void drawRightArrowLine();
void drawArrowUp();									// draw upArrow
void drawArrowUpLine();
void drawEggTimer();								// draw EggTimer
void drawEggTimerLine();
void drawHouse();									// draw house
void drawHouseLine();
void drawRectangle();								// draw rectangle
void drawRectangleLine();
void drawRhombus();									// draw a rhombus
void drawRhombusLine();	
void drawParallelogram();							// draw a parallelogram
void drawParallelogramLine();
void drawTrig();									// draw a triangle
void drawTrigLine();
void drawSquare();									// draw square
void drawSquareLine();
void drawCircle();									// draw a circle
void drawCircleLine();
void drawElipse();									// draw elipse
void drawElipseLine();
void drawElipse1();									// draw elipse1
void drawElipse1Line();
void drawHexagon();									// draw hexagon
void drawHexagonLine();	
void drawPentagon();							    // draw pentagon
void drawPentagonLine();
void drawDiamond();									// draw diamond
void drawDiamondLine();	
void drawShape1();									// draw shape1
void drawShape1Line();	
void drawArrowDown();								// draw downArrow
void drawArrowDownLine();

void initializeViewport();							// setup viewport

//double getWordsPerMinute();
double getLettersPerMinute(double elapsed);

listNode addListNode(double xp,double yp,double xs,double ys,fp rf,GLfloat *c,GLfloat *c1); 
//listNode addListNode(double xp,double yp,double xs,double ys,fp rfl,GLfloat *c,GLfloat *c1); 

// GLUT callback function prototypes
void idle(void);		// GLUT idle function
void display(void);		// GLUT display function
void keyboard(unsigned char key, int x, int y);

// main function (program entry)
int main(int argc,char *argv[])
{
  /* initialise GLUT */
  glutInit(&argc,argv); /* initialise GLUT */
  glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_ACCUM|GLUT_DEPTH);
  glutInitWindowSize(WIN_WIDTH,WIN_HEIGHT);
  glutInitWindowPosition(50,50);
  glutCreateWindow("Innovations program");

  /* setup all for OpenGL */ 
  initializeViewport();
  initLookupTable();
  initLookupTableLine();

  /* set display callback function */
  glutDisplayFunc(display);
  glutIdleFunc(idle);
  glutKeyboardFunc(keyboard);

  GLfloat color[4];
  GLfloat color1[4];
  // add list elements
  makeColor(color,0.0,0.0,0.0,1.0,0.0,0.0,0.0,1.0);
  //linkedList.push_front(addListNode(0.0,0.0,0.0,2.0,&drawRhombus,color));
//  linkedList.``(addListNode(70.0,70.0,0.0,0.0,drawTrig,color));
  //linkedList.pop_front();
  //linkedList.push_front(addListNode(140.0,140.0,0.0,-2.0,&drawSquare,color));
 

  /* start program loop */
  glutMainLoop();
  return 0;
}

// functions
void initializeViewport()
{
  glClearColor(0.0,0.0,0.0,0.0); /* black */
  /* select the colour for clearing the window */

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity(); /* identity matrix */
  /* set to orthographic projection */
  gluOrtho2D(0.0,(GLdouble)WIN_WIDTH, 0.0, (GLdouble)WIN_HEIGHT);
  glClear(GL_COLOR_BUFFER_BIT); /* CLS */
  glMatrixMode(GL_MODELVIEW);

  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glShadeModel(GL_SMOOTH);
}

void drawTrig()
{
  glBegin(GL_POLYGON);
//  glColor3f(0.0,0.0,1.0); /* blue */
  glVertex2i(0,0);
//  glColor3f(0.0,1.0,0.0); /* green */
  glVertex2i(60,0);
//  glColor3f(1.0,0.0,0.0); /* red */
  glVertex2i(30,60);
  glEnd();
 }


void drawTrigLine()
{
  glBegin(GL_LINE_LOOP);
  glColor3f(1.0,0.0,0.0); /* red */
  glVertex2i(0,0);
  glVertex2i(65,0);
  glVertex2i(25,65);
  glEnd();
}

void drawCircle()
{
	int i;
	float angle;
	GLint circle_points=24;
	glBegin(GL_POLYGON);
	for(i=0;i<circle_points;i++)
	{
		angle = 2*PI*i/circle_points;
		glVertex2f(cos(angle)*35, sin(angle)*35);
	}
	glEnd();
}

void drawCircleLine()
{
	int i;
	float angle;
	GLint circle_points=24;
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0);
	for(i=0;i<circle_points;i++)
	{
		angle = 2*PI*i/circle_points;
		glVertex2f(cos(angle)*35, sin(angle)*35);
	}
	glEnd();
}

void drawElipse()
{
	int i;
	float angle;
	GLint circle_points=24;
	glBegin(GL_POLYGON);
	for(i=0;i<circle_points;i++)
	{
		angle = 2*PI*i/circle_points;
		glVertex2f(cos(angle)*25, sin(angle)*35);
	}
	glEnd();
}

void drawElipseLine()
{
	int i;
	float angle;
	GLint circle_points=24;
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0);
	for(i=0;i<circle_points;i++)
	{
		angle = 2*PI*i/circle_points;
		glVertex2f(cos(angle)*25, sin(angle)*35);
	}
	glEnd();
}

void drawElipse1()
{
	int i;
	float angle;
	GLint circle_points=24;
	glBegin(GL_POLYGON);
	for(i=0;i<circle_points;i++)
	{
		angle = 1*PI*i/circle_points;
		glVertex2f(cos(angle)*25, sin(angle)*35);
	}
	glEnd();
}


void drawElipse1Line()
{
	int i;
	float angle;
	GLint circle_points=24;
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0);
	for(i=0;i<circle_points;i++)
	{
		angle = 1*PI*i/circle_points;
		glVertex2f(cos(angle)*25, sin(angle)*35);
	}
	glEnd();
}


void drawParallelogram()
{
	glBegin(GL_POLYGON);
	//glColor3f(1.0,0.0,0.0); //red
	glVertex2i(0,0);
	glVertex2i(60,0);
	glVertex2i(120,60);
	glVertex2i(60,60);
	glEnd();
}


void drawParallelogramLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); //red
	glVertex2i(0,0);
	glVertex2i(60,0);
	glVertex2i(120,60);
	glVertex2i(60,60);
	glEnd();
}

void drawRhombus()
{
	glBegin(GL_POLYGON);
	glVertex2i(0,0);
	glVertex2i(60,0);
	glVertex2i(40,60);
	glVertex2i(20,60);
	glEnd();
}

void drawRhombusLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); //red
	glVertex2i(0,0);
	glVertex2i(60,0);
	glVertex2i(40,60);
	glVertex2i(20,60);
	glEnd();
}


void drawSquare()
{
	glBegin(GL_POLYGON);
	glVertex2i(0,0);
	glVertex2i(60,0);
	glVertex2i(60,60);
	glVertex2i(0,60);
	glEnd();
}



void drawSquareLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); //red
	glVertex2i(0,0);
	glVertex2i(60,0);
	glVertex2i(60,60);
	glVertex2i(0,60);
	glEnd();
}

void drawHexagon()
{
	glBegin(GL_POLYGON);
	glVertex2i(40,10);
	glVertex2i(100,10);
	glVertex2i(120,40);
	glVertex2i(100,70);
	glVertex2i(40,70);
    glVertex2i(20,40);
	glEnd();
}


void drawHexagonLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); //red
	glVertex2i(40,10);
	glVertex2i(100,10);
	glVertex2i(120,40);
	glVertex2i(100,70);
	glVertex2i(40,70);
    glVertex2i(20,40);
	glEnd();
}


void drawPentagon()
{
	glBegin(GL_POLYGON);
	glVertex2i(40,10);
	glVertex2i(80,10);
	glVertex2i(90,40);
	glVertex2i(60,70);
	glVertex2i(30,40);
	glEnd();
}

void drawPentagonLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); //green
	glVertex2i(40,10);
	glVertex2i(80,10);
	glVertex2i(90,40);
	glVertex2i(60,70);
	glVertex2i(30,40);
	glEnd();
}

void drawDiamond()
{
	glBegin(GL_POLYGON);
	glVertex2i(50,10);
	glVertex2i(30,25);
	glVertex2i(50,50);
	glVertex2i(70,25);
	glEnd();
}


void drawDiamondLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); //blue
	glVertex2i(50,10);
	glVertex2i(30,25);
	glVertex2i(50,50);
	glVertex2i(70,25);
	glEnd();
}


void drawShape1()
{
	glBegin(GL_POLYGON);
	glVertex2i(60,10);
	glVertex2i(30,40);
	glVertex2i(50,40);
	glVertex2i(60,50);
	glVertex2i(70,40);
	glVertex2i(90,40);
	glEnd();
}


void drawShape1Line()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); //purple
	glVertex2i(60,10);
	glVertex2i(30,40);
	glVertex2i(50,40);
	glVertex2i(60,50);
	glVertex2i(70,40);
	glVertex2i(90,40);
	glEnd();
}

void drawRectangle()
{
	glBegin(GL_POLYGON);
	glVertex2i(10,10);
	glVertex2i(100,10);
	glVertex2i(100,50);
	glVertex2i(10,50);
	glEnd();
}

void drawRectangleLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); //brown
	glVertex2i(10,10);
	glVertex2i(100,10);
	glVertex2i(100,50);
	glVertex2i(10,50);
	glEnd();
}

void drawHouse()
{
	glBegin(GL_POLYGON);
	glVertex2i(10,10);
	glVertex2i(100,10);
	glVertex2i(100,50);
	glVertex2i(80,70);
	glVertex2i(30,70);
	glVertex2i(10,50);
	glEnd();
}

void drawHouseLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Bright Green
	glVertex2i(10,10);
	glVertex2i(100,10);
	glVertex2i(100,50);
	glVertex2i(80,70);
	glVertex2i(30,70);
	glVertex2i(10,50);
	glEnd();
}

void drawEggTimer()
{
	glBegin(GL_POLYGON);
	glVertex2i(40,10);
	glVertex2i(100,10);
	glVertex2i(120,40);
	glVertex2i(120,60);
	glVertex2i(100,90);
	glVertex2i(120,120);
	glVertex2i(120,140);
	glVertex2i(100,170);
	glVertex2i(40,170);
	glVertex2i(20,140);
	glVertex2i(20,120);
	glVertex2i(40,90);
	glVertex2i(20,60);
	glVertex2i(20,40);
	glEnd();
}


void drawEggTimerLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Bright Blue
	glVertex2i(40,10);
	glVertex2i(100,10);
	glVertex2i(120,40);
	glVertex2i(120,60);
	glVertex2i(100,90);
	glVertex2i(120,120);
	glVertex2i(120,140);
	glVertex2i(100,170);
	glVertex2i(40,170);
	glVertex2i(20,140);
	glVertex2i(20,120);
	glVertex2i(40,90);
	glVertex2i(20,60);
	glVertex2i(20,40);
	glEnd();
}

void drawArrowUp()
{
	glBegin(GL_POLYGON);
	glVertex2i(40,10);
	glVertex2i(40,60);
	glVertex2i(20,60);
	glVertex2i(20,10);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(60,60);
	glVertex2i(30,80);
	glVertex2i(0,60);
	glEnd();
}

void drawArrowUpLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Deep Blue
	glVertex2i(40,10);
	glVertex2i(40,60);
	glVertex2i(20,60);
	glVertex2i(20,10);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(60,60);
	glVertex2i(30,80);
	glVertex2i(0,60);
	glEnd();
}


void drawRightArrow()
{
	glBegin(GL_POLYGON);
	glVertex2i(40,40);
	glVertex2i(60,40);
	glVertex2i(60,80);
	glVertex2i(40,80);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(60,40);
	glVertex2i(80,60);
	glVertex2i(60,80);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(40,80);
	glVertex2i(20,80);
	glVertex2i(40,60);
	glEnd();	
	glBegin(GL_POLYGON);
	glVertex2i(40,40);
	glVertex2i(40,60);
	glVertex2i(20,40);
	glEnd();
}


void drawRightArrowLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Deep Pink
	glVertex2i(40,40);
	glVertex2i(60,40);
	glVertex2i(60,80);
	glVertex2i(40,80);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(60,40);
	glVertex2i(80,60);
	glVertex2i(60,80);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(40,80);
	glVertex2i(20,80);
	glVertex2i(40,60);
	glEnd();	
	glBegin(GL_POLYGON);
	glVertex2i(40,40);
	glVertex2i(40,60);
	glVertex2i(20,40);
	glEnd();
	
}

void drawArrowDown()
{
	glBegin(GL_POLYGON);
	glVertex2i(40,40);
	glVertex2i(40,100);
	glVertex2i(20,100);
	glVertex2i(20,40);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(60,40);
	glVertex2i(30,10);
	glVertex2i(0,40);
	glEnd();
}

void drawArrowDownLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Peach
	glVertex2i(40,40);
	glVertex2i(40,100);
	glVertex2i(20,100);
	glVertex2i(20,40);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(60,40);
	glVertex2i(30,10);
	glVertex2i(0,40);
	glEnd();
}

void drawHammer()
{
	glBegin(GL_POLYGON);
	glVertex2i(20,10);
	glVertex2i(40,10);
	glVertex2i(40,40);
	glVertex2i(20,40);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(60,40);
	glVertex2i(60,80);
	glVertex2i(0,80);
	glVertex2i(0,40);
	glEnd();
}

void drawHammerLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Deep Blue
	glVertex2i(20,10);
	glVertex2i(40,10);
	glVertex2i(40,40);
	glVertex2i(20,40);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(60,40);
	glVertex2i(60,80);
	glVertex2i(0,80);
	glVertex2i(0,40);
	glEnd();
}

void draw4Star()
{
	glBegin(GL_POLYGON);
	glVertex2i(90,40);
	glVertex2i(110,70);
	glVertex2i(90,90);
	glVertex2i(70,70);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(90,90);
	glVertex2i(110,70);
	glVertex2i(140,90);
	glVertex2i(110,110);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(90,90);
	glVertex2i(110,110);
	glVertex2i(90,140);
	glVertex2i(70,110);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(90,90);
	glVertex2i(70,110);
	glVertex2i(40,90);
	glVertex2i(70,70);
	glEnd();
}

void draw4StarLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Deep Blue
	glVertex2i(90,40);
	glVertex2i(110,70);
	glVertex2i(90,90);
	glVertex2i(70,70);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(90,90);
	glVertex2i(110,70);
	glVertex2i(140,90);
	glVertex2i(110,110);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(90,90);
	glVertex2i(110,110);
	glVertex2i(90,140);
	glVertex2i(70,110);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(90,90);
	glVertex2i(70,110);
	glVertex2i(40,90);
	glVertex2i(70,70);
	glEnd();
}

void drawHeart()
{
	glBegin(GL_POLYGON);
	glVertex2i(40,20);
	glVertex2i(60,60);
	glVertex2i(40,50);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(40,20);
	glVertex2i(40,50);
	glVertex2i(20,60);
	glEnd();
}

void drawHeartLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Deep Blue
	glVertex2i(40,20);
	glVertex2i(60,60);
	glVertex2i(40,50);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(40,20);
	glVertex2i(40,50);
	glVertex2i(20,60);
	glEnd();
}

void drawVan()
{
	glBegin(GL_POLYGON);
	glVertex2i(20,20);
	glVertex2i(120,20);
	glVertex2i(120,80);
	glVertex2i(40,80);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(45,65);
	glVertex2i(65,65);
	glVertex2i(65,45);
	glVertex2i(45,45);
	glEnd();
}

void drawVanLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Off red
	glVertex2i(20,20);
	glVertex2i(120,20);
	glVertex2i(120,80);
	glVertex2i(40,80);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(45,65);
	glVertex2i(65,65);
	glVertex2i(65,45);
	glVertex2i(45,45);
	glEnd();
}

void drawZigZag()
{
	glBegin(GL_POLYGON);
	glVertex2i(20,20);
	glVertex2i(40,20);
	glVertex2i(50,40);
	glVertex2i(30,40);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(30,40);
	glVertex2i(50,40);
	glVertex2i(40,60);
	glVertex2i(20,60);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(20,60);
	glVertex2i(40,60);
	glVertex2i(50,80);
	glVertex2i(30,80);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(30,80);
	glVertex2i(50,80);
	glVertex2i(40,100);
	glVertex2i(20,100);
	glEnd();
}

void drawZigZagLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Yellow
	glVertex2i(20,20);
	glVertex2i(40,20);
	glVertex2i(50,40);
	glVertex2i(30,40);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(30,40);
	glVertex2i(50,40);
	glVertex2i(40,60);
	glVertex2i(20,60);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(20,60);
	glVertex2i(40,60);
	glVertex2i(50,80);
	glVertex2i(30,80);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(30,80);
	glVertex2i(50,80);
	glVertex2i(40,100);
	glVertex2i(20,100);
	glEnd();
}

void drawCross()
{
	glBegin(GL_POLYGON);
	glVertex2i(40,20);
	glVertex2i(50,20);
	glVertex2i(50,120);
	glVertex2i(40,120);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(20,70);
	glVertex2i(70,70);
	glVertex2i(70,90);
	glVertex2i(20,90);
	glEnd();
}

void drawCrossLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Bright Green
	glVertex2i(40,20);
	glVertex2i(50,20);
	glVertex2i(50,120);
	glVertex2i(40,120);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(20,70);
	glVertex2i(70,70);
	glVertex2i(70,90);
	glVertex2i(20,90);
	glEnd();
}

void drawCracker()
{
	glBegin(GL_POLYGON);
	glVertex2i(20,20);
	glVertex2i(40,40);
	glVertex2i(30,40);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(60,20);
	glVertex2i(40,40);
	glVertex2i(50,40);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(30,40);
	glVertex2i(50,40);
	glVertex2i(50,80);
	glVertex2i(30,80);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(20,100);
	glVertex2i(40,80);
	glVertex2i(30,80);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(40,80);
	glVertex2i(50,80);
	glVertex2i(60,100);
	glEnd();
}

void drawCrackerLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Off purple
	glVertex2i(20,20);
	glVertex2i(40,40);
	glVertex2i(30,40);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(60,20);
	glVertex2i(40,40);
	glVertex2i(50,40);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(30,40);
	glVertex2i(50,40);
	glVertex2i(50,80);
	glVertex2i(30,80);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(20,100);
	glVertex2i(40,80);
	glVertex2i(30,80);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(40,80);
	glVertex2i(50,80);
	glVertex2i(60,100);
	glEnd();
}

void drawX()
{
	glBegin(GL_POLYGON);
	glVertex2i(30,20);
	glVertex2i(20,30);
	glVertex2i(70,80);
	glVertex2i(80,70);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(70,20);
	glVertex2i(80,30);
	glVertex2i(30,80);
	glVertex2i(20,70);
	glEnd();
}

void drawXLine()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Bright Green
	glVertex2i(30,20);
	glVertex2i(20,30);
	glVertex2i(70,80);
	glVertex2i(80,70);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex2i(70,20);
	glVertex2i(80,30);
	glVertex2i(30,80);
	glVertex2i(20,70);
	glEnd();
}

void drawShape2()
{
	glBegin(GL_POLYGON);
	glVertex2i(60,20);
	glVertex2i(50,40);
	glVertex2i(30,40);
	glVertex2i(20,20);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(60,60);
	glVertex2i(20,60);
	glVertex2i(30,40);
	glVertex2i(50,40);
	glEnd();
}

void drawShape2Line()
{
	glBegin(GL_LINE_LOOP);
	//glColor3f(1.0,0.0,0.0); // Bright Green
	glVertex2i(60,20);
	glVertex2i(50,40);
	glVertex2i(30,40);
	glVertex2i(20,20);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex2i(60,60);
	glVertex2i(20,60);
	glVertex2i(30,40);
	glVertex2i(50,40);
	glEnd();
}

void initLookupTable()
{
	lookup_table[0]=&drawTrig;
	lookup_table[1]=&drawSquare;
	lookup_table[2]=&drawRhombus;
	lookup_table[3]=&drawParallelogram;
	lookup_table[4]=&drawCircle;
	lookup_table[5]=&drawHexagon;
	lookup_table[6]=&drawPentagon;
	lookup_table[7]=&drawDiamond;
	lookup_table[8]=&drawShape1;
	lookup_table[9]=&drawRectangle;
	lookup_table[10]=&drawHouse;
	lookup_table[11]=&drawEggTimer;
	lookup_table[12]=&drawArrowUp;
	lookup_table[13]=&drawElipse;
	lookup_table[14]=&drawArrowDown;
	lookup_table[15]=&drawElipse1;
	lookup_table[16]=&drawRightArrow;
	lookup_table[17]=&drawHammer;
	lookup_table[18]=&drawHeart;
	lookup_table[19]=&drawVan;
	lookup_table[20]=&draw4Star;
	lookup_table[21]=&drawZigZag;
	lookup_table[22]=&drawCross;
	lookup_table[23]=&drawCracker;
	lookup_table[24]=&drawX;
	lookup_table[25]=&drawShape2;
}

void initLookupTableLine()
{
	lookup_tableLine[0]=&drawTrigLine;
	lookup_tableLine[1]=&drawSquareLine;
	lookup_tableLine[2]=&drawRhombusLine;
	lookup_tableLine[3]=&drawParallelogramLine;
	lookup_tableLine[4]=&drawCircleLine;
	lookup_tableLine[5]=&drawHexagonLine;
	lookup_tableLine[6]=&drawPentagonLine;
	lookup_tableLine[7]=&drawDiamondLine;
	lookup_tableLine[8]=&drawShape1Line;
	lookup_tableLine[9]=&drawRectangleLine;
	lookup_tableLine[10]=&drawHouseLine;
	lookup_tableLine[11]=&drawEggTimerLine;
	lookup_tableLine[12]=&drawArrowUpLine;
	lookup_tableLine[13]=&drawElipseLine;
	lookup_tableLine[14]=&drawArrowDownLine;
	lookup_tableLine[15]=&drawElipse1Line;
	lookup_tableLine[16]=&drawRightArrowLine;
	lookup_tableLine[17]=&drawHammerLine;
	lookup_tableLine[18]=&drawHeartLine;
	lookup_tableLine[19]=&drawVanLine;
	lookup_tableLine[20]=&draw4StarLine;
	lookup_tableLine[21]=&drawZigZagLine;
	lookup_tableLine[22]=&drawCrossLine;
	lookup_tableLine[23]=&drawCrackerLine;
	lookup_tableLine[24]=&drawXLine;
	lookup_tableLine[25]=&drawShape2Line;
}

void makeColor(GLfloat *c,GLfloat *c1,GLfloat r, GLfloat g, GLfloat b,GLfloat a,GLfloat r1, GLfloat g1, GLfloat b1,GLfloat a1)
{
	c[0]=r;
	c[1]=g;
	c[2]=b;
	c[3]=a;
	c1[0]=r1;
	c1[1]=g1;
	c1[2]=b1;
	c1[3]=a1;
}

float decay (float d)
{
	if(d==0)
		return 0;
	else
		return d=d-0.1;
}

/*void size();
{
	
	if(a==0.0)
		break;
	if(b==0.0)
		break; 
	while ((a>0.0) && (b>0.0))
	{
		a-=0.1;
		cout << "A size" << a << endl;
		b-=0.1;
		cout << "B size" << b << endl;
	}
} */

void draw(list<listNode> &base)
{
	
	list<listNode>::iterator node=base.begin();
	while(node!=base.end())
	{
		glLoadIdentity();
		glTranslated(node->xpos,node->ypos,0.0);
		//drawTrig();
		//drawSquare();
		
		glRotatef(node->angle,10.0,10.0,0.0);
		glScalef(node->sizeX,node->sizeY,0.0);
		glColor4fv(node->color);
			
		//glColor4fv(node->color1);
		//cout << "color r " << node->color1[0] << endl;
		//cout << "color g " << node->color1[1] << endl;
		//cout << "color b " << node->color1[2] << endl;
		//cout << "Alpha " << node->color1[3] << endl;
		node->renderFunction();
		
		//drawRhombus();
		//drawCircle();
		node++;  // move to next node in list
	}
}

void update(list<listNode> &base,double elapsed)
{

	
	GLfloat c[4];
	list<listNode>::iterator node=base.begin();
	while(node!=base.end())
	{
		if(node->ypos<0.0)
		{
			node->ypos=0.0;
			node->yspeed=0.0;
			node->xspeed=-5.0;
//			node->color;
		}
		else if(node->ypos>720.0)
		{
			node->ypos=720.0;
			node->yspeed=0.0;
			node->xspeed=5.0;
		}
		else if(node->xpos<0.0)
		{
			node->xpos=0.0;
			node->xspeed=0.0;
			node->yspeed=5.0;
		}
		else if(node->xpos>720.0)
		{
			node->xpos=720.0;
			node->xspeed=0.0;
			node->yspeed=-5.0;
		}
		node->xpos+=(node->xspeed*elapsed*18.0);
		node->ypos+=(node->yspeed*elapsed*18.0);

		node->color[0]-=0.1*elapsed;
		node->color[1]-=0.01*elapsed;
		node->color[2]+=0.1*elapsed;
		node->color[3]-=0.1*elapsed;

		node->color1[0]=0.0;
		node->color1[1]=1.0;
		node->color1[2]=0.0;
		node->color1[3]-=0.001*elapsed;
		//cout<<"Alpha 1: " <<node->color1<<endl;

		/*while ((node->sizeX>=0.0) && (node->sizeX<=5.0))
		{
			while((node->sizeY>=0.0) && (node->sizeY<=5.0))
			{
			node->sizeX+=0.1;
			cout << "X size" << node->sizeX << endl;
			node->sizeY+=0.1;
			cout << "Y size" << node->sizeY << endl;
			
			}
		}  */

		//node->angle+=0.5*elapsed;

		node->sizeX+=0.1*elapsed;
		//cout << "Size X " << node->sizeX << endl;
		node->sizeY+=0.1*elapsed;
		//cout << "Size Y " << node->sizeY << endl;
		
		if(node->color[3]<=0.0)
			node->color[3]=0.0;
		//int i;
		/*for(i=0;i<3;i++)
		{
			if(node->color[i]==1.0)
			node->color[i]=0.0;
		} 

		if(node->color1[3]<=0.0)
			node->color1[3]=0.0;*/
		//int i;
		//for(i=0;i<3;i++)
		//{
		//	if(node->color1[i]==1.0)
		//	node->color1[i]=0.0;
		//} 
	//	cout << "alpha = " << node->color[3] << endl;
			node->expiryDate-=0.001;
		// completely removing a node from the list
//		if(node->expiryDate<=0.0)
//		{
//			base.remove(node);
//			base.erase(base.end());
//		}

        node++;
	}
}


void set (GLfloat *c)  //sets the start colour of every shape
{
	int i;
	//for(i=0;i<3;i++)
	c[0]=0.0;
	c[1]=0.0;
	c[2]=0.0;
	//	cout << "Red :" <<c[0] << endl;
	//	cout << "Green :" <<c[1] << endl;
	//	cout << "Blue :" <<c[2] << endl;
	//srand((unsigned) time(NULL));
	//const double maxInt = RAND_MAX;
	for(int i=0;i<3;i++)
	{
	//if(c[i]==0.0)
	while(c[i]<=1.0)
	{
		c[i]+=0.1;
	//	cout << "Red Add : " << c[0] << endl;
	}
	//if(c[i]==1.0)
	while(c[i]>=0.0)
	{
		c[i]-=0.1;
	//	cout << "Red Minus : " << c[0] << endl;
	}
	//cout << "R Color : " << c[0] << endl;
	}
}


double getLettersPerMinute(double elapsed)  // keysPerMinute.elapsed();
{
	return 60.0/elapsed;
}

listNode addListNode(double xp,double yp,double xs,double ys,fp rf,GLfloat *c,GLfloat *c1)
{
	srand((unsigned) time(NULL));
	const double maxInt = RAND_MAX;
	listNode ret;
	ret.xpos=xp;//rand()/maxInt*400;			//multiply by 400 due to the width of the screen
	ret.xspeed=xs;
	ret.ypos=yp;//rand()/maxInt*400;			//multiply by 400 due to height of the screen
	ret.yspeed=ys;
	ret.renderFunction=rf;
	//ret.renderFunctionLine=rfl;
	ret.expiryDate=100.0;
	set(c);
//	set(c1);
	for(int i=0;i<4;i++)
		ret.color[i]=c[i];
	for(int j=0;j<4;j++)
		ret.color1[j]=c[j];
	return ret;
}

// GLUT callback functions

void keyboard(unsigned char key, int x, int y)
{
//	printf("Character: %c - Value: %d\n",key,key);
  //static GLfloat color[4]={1.0,0.0,0.0,1.0};
  //static GLfloat color1[4]={0.0,1.0,0.0,1.0};
  double px,py,sx,sy;


  srand((unsigned) time(NULL));
  const double maxInt = RAND_MAX;
  
  px=rand()/maxInt*WIN_WIDTH;  // so it's a different value every time
  px=rand()/maxInt*WIN_WIDTH;
//  cout << "Px = " << px << endl;
  py=rand()/maxInt*WIN_HEIGHT;
//  cout << "Py = " << py << endl;
  sx=-1.0;
  sy=-1.0;
  keysPerMinute.update();


  makeColor(color,color1,1.0,0.0,0.0,1.0,0.0,1.0,0.0,1.0);

	int ki; // key index
	int ka;
	ki=key-'a';
	ka=ki;;
	switch(key)
	{
	case 8:
		linkedList.pop_front();		//backspace
		linkedList1.pop_front();
		break;
	case 27:
		exit(0);
		break;		//escape
	case 39:break;	//apostrophie
	case 44:break;  //comma
	case 46:break;	//full stop
	case ' ': break;	//space bar
	default:
		{
		linkedList1.push_front(addListNode(px,py,sx,sy,lookup_tableLine[ki],color));
		cout << "Node added to linked list 1 " <<endl;
		linkedList.push_front(addListNode(px,py,sx,sy,lookup_table[ki],color));
		cout << "Node added to linked list  " <<endl;
		
		}
	}
	cout << "" << key ;

	
	textSetBitmapFont();
	textPrintf(100.0, 100.0,"100");
	
//	printf("%f\n",getLettersPerMinute(keysPerMinute.getElapsed()));
	glutPostRedisplay();
}

void display(void) /* display callback */
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    timer.update();

	update(linkedList,timer.getElapsed());
	update(linkedList1,timer.getElapsed());
	
	draw(linkedList);
	draw(linkedList1);
	    
	int jitter;
	
/*
	for(jitter=0;jitter < DECAY;jitter++)
	{
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_ACCUM_BUFFER_BIT);
		//displayObjects();
		
		draw(linkedList);
		//cout << "Decay Value"<< DECAY <<endl;
		//cout << "Jitter Value"<<  jitter<<endl;
		glAccum(GL_ACCUM, 1.0/jitter);
		glFlush();
	
	}
	glAccum(GL_RETURN,1.0);
*/
    glFlush(); /* force buffers onto screen */
    glutSwapBuffers();
}

void idle()
{
    glutPostRedisplay();
}







