#ifndef IMAGE_H
#define IMAGE_H

#include<stdlib.h>
#include<stdio.h>
#include<string.h>

typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef long LONG;
typedef unsigned char BYTE;

#pragma warning(disable:4103)
#pragma pack(2)
#define BI_RGB 0L

typedef struct{ 
  WORD    bfType; 
  DWORD   bfSize; 
  WORD    bfReserved1; 
  WORD    bfReserved2; 
  DWORD   bfOffBits; 
} mBITMAPFILEHEADER;

typedef struct{
  DWORD  biSize; 
  LONG   biWidth; 
  LONG   biHeight; 
  WORD   biPlanes; 
  WORD   biBitCount; 
  DWORD  biCompression; 
  DWORD  biSizeImage; 
  LONG   biXPelsPerMeter; 
  LONG   biYPelsPerMeter; 
  DWORD  biClrUsed; 
  DWORD  biClrImportant; 
} mBITMAPINFOHEADER; 

typedef struct
{
  BYTE    rgbBlue; 
  BYTE    rgbGreen; 
  BYTE    rgbRed; 
  BYTE    rgbReserved; 
} mRGBQUAD;

typedef struct
{ 
  mBITMAPINFOHEADER bmiHeader; 
  mRGBQUAD          bmiColors[1]; 
} mBITMAPINFO; 

typedef struct
{
  BYTE red, green, blue;
} pixel;

typedef struct{
	int width;
	int height;
	pixel *pixels;
} image;

int xyToIndex(int,int,int);
int allocateImage(image *,int,int);
void freeImage(image *);
int clearImage(image *);
int getImageWidth(image*);
int getImageHeight(image*);
pixel* getImage(image*);
int loadImage(char *,image *);
int saveImage(char *,image *);

#endif
